// mstring.cpp - dynamic string class, should be thread safe on WIN32

/***************************************************************************
              +++ testing to-do +++
			  Test thread safety...
****************************************************************************/
//#include <windows.h>	//included to be thread safe..
#include <iostream>	//IOS
#include <string>		//string RTL - someday we could eliminate this, but speed would suffer
#include <stdlib.h>		
#include <assert.h>		//assertion libs
#include <ctype.h>		//type converts
#include <math.h>		//for pow() used in hash function
#include <new.h>		// this library will assume the new handler is set.

#include "mstring.h"


using namespace std;

/*******************************************
	String Class Implementation
********************************************/

// *** NO-ARG CONSTRUCTOR
// **********************
String::String()
{
	m_case = 1;
	str.clear();
}

// *** ONE-ARG CONSTRUCTOR
// ***********************
String::String(const char *instring)
{
	if ((instring == NULL) || (instring[0] == 0x00))	{
		str.clear();
		}
	else	{
		str = instring;
	}
	m_case = 1;
}

// *** DESTRUCTOR
// **************
String::~String()
{
	if(!str.isnull())	{
		str.clear();
		}
}

// *** COPY CONSTRUCTOR(s)
// ***********************
String::String(const String &other)
{
    if(!other.str.isnull())    {
    	str = other.str;
    }
    else    {
        str.clear();
    }
}

String::String(const String &x, int s, int c) 
{
    assert(s <= x.str._len);
    assert((s + c) <= x.str._len);
    NEW_PTR(str._str,c)
    if(x.str._len > 0)
        strncpy(str._str,x.str._str + s, c);
    str._len = c + 1;
    if(str._str != NULL)
        str._str[c] = '\0';
	nilchar = '\0';
}

// *** OVERLOAD PLUS-EQUALS
// ************************
String &String::operator += (const String &other)
{
	append(other);
	return *this;
}

// *** OVERLOAD PLUS-EQUALS
// ************************
String &String::operator += (const char  *instr)
{
	append(instr);
	return *this;
}

// *** OVERLOAD MINUS-EQUALS
// ************************
String &String::operator -= (const String &other)
{
	substrrpl(other.c_str(),"",1);
	return *this;
}

// *** OVERLOAD MINUS-EQUALS
// ************************
String &String::operator -= (const char  *instr)
{
	substrrpl(instr,"",1);
	return *this;
}

// *** OVERLOAD ()
// *****************
char String::operator () (int index)
{
   	return str[index];
}

// *** OVERLOAD ()
// *****************
//see the substr() function for my comments....
String String::operator () (int index, int n)
{
	return substr(index,n);
}

/*
String String::operator + (const String &aa, const String &bb)
{
	return add(aa.c_str(),bb.c_str());
}

String String::operator + (const char  *aa, const String &bb)
{
	return add(aa,bb.c_str());
}

String String::operator + (const String &aa, const char *bb)
{
	return add(aa.c_str(),bb);
}

String String::operator + (const char  *aa, const char *bb)
{
	return add(aa,bb);
}

*/

/*
    Not implemented yet.
String String::operator - (const String &aa, const String &bb)
{
	String Temp;
}

String String::operator - (const char  *aa, const String &bb)
{
	String Temp;
}

String String::operator - (const String &aa, const char *bb)
{
	String Temp;
}

String String::operator - (const char  *aa, const char *bb)
{
	String Temp;
}
*/

// *** OVERLOAD COMPARISON
// ***********************
BOOL String::operator == (String &ss)
{
    if((!str.isnull()) && (!ss.str.isnull()))
    	return((strcmp(str._str,ss.c_str()) == 0) ? 1 : 0);
    else
        return (str._str == ss.c_str()) ? 1 : 0;
}

BOOL String::operator == (const char  *ss)
{
    if((!str.isnull()) && (ss != NULL))
    	return((strcmp(str._str,ss) == 0) ? 1 : 0);
    else
        return (str._str == ss) ? 1 : 0;
}

BOOL String::operator != (String &ss)
{
    if((!str.isnull()) && (!ss.str.isnull()))
    	return((strcmp(str._str,ss.c_str()) == 0) ? 0 : 1);
    else
        return (str._str == ss.c_str()) ? 0 : 1;
}

BOOL String::operator != (const char  *ss)
{
    if((!str.isnull()) && (ss != NULL))
    	return((strcmp(str._str,ss) == 0) ? 0 : 1);
    else
        return (str._str == ss) ? 0 : 1;
}

BOOL String::operator > (String ss)
{
    if((!str.isnull()) && (!ss.str.isnull()))
    	return((strcmp(str._str,ss.c_str()) > 0) ? 1 : 0);
    else
        return (str._str > ss.c_str()) ? 1 : 0;
}

BOOL String::operator > (const char * ss)
{
    if((!str.isnull()) && (ss != NULL))
    	return((strcmp(str._str,ss) > 0) ? 1 : 0);
    else
        return (str._str > ss) ? 1 : 0;
}

BOOL String::operator < (String ss)
{
    if((!str.isnull()) && (!ss.str.isnull()))
    	return((strcmp(str._str,ss.c_str()) < 0) ? 1 : 0);
    else
        return (str._str < ss.c_str()) ? 1 : 0;
}

BOOL String::operator < (const char * ss)
{
    if((!str.isnull()) && (ss != NULL))
    	return((strcmp(str._str,ss) < 0) ? 1 : 0);
    else
        return (str._str < ss) ? 1 : 0;
}

BOOL String::operator <= (String ss)
{
	if(((*this) < ss)	||
		((*this) == ss))	{
		return 1;
		}
	else	{
		return 0;
		}
}

BOOL String::operator <= (const char * ss)
{
	if(((*this) < ss)	||
		((*this) == ss))	{
		return 1;
		}
	else	{
		return 0;
		}
}

BOOL String::operator >= (String ss)
{
	if(((*this) > ss)	||
		((*this) == ss))	{
		return 1;
		}
	else	{
		return 0;
		}
}



BOOL String::operator >= (const char * ss)
{
	if(((*this) > ss)	||
		((*this) == ss))	{
		return 1;
		}
	else	{
		return 0;
		}
}

//bitwise operators...
String  &String::operator |= (String &other)
{
    int i = 0,j = 0;

	GrabMutex();
    if((!str.isnull()) && (!other.str.isnull())) {
        while(str._str[j] && other.str._str[i])   {
            str._str[j] |= other.str._str[i];
            i++; j++;
        }
    }
	FreeMutex();
    return (*this);
}

String  &String::operator &= (String &other)
{
    int i = 0,j = 0;

	GrabMutex();
    if((!str.isnull()) && (!other.str.isnull()))   {
        while(str._str[j] && other.str._str[i])   {
            str._str[j] &= other.str._str[i];
            i++; j++;
        }
    }
	FreeMutex();
    return (*this);
}

String  &String::operator ^= (String &other)
{
    int i = 0,j = 0;

	GrabMutex();
    if((!str.isnull()) && (!other.str.isnull())){
        while(str._str[j] && other.str._str[i]) {
            str._str[j] ^= other.str._str[i];
            i++; j++;
        }
    }
	FreeMutex();
    return (*this);
}

int String::allocate( int size, const char fc )
{
	char *Temp;

	if (!str.isnull())	{
		str.clear();
		}
	NEW_PTR(Temp,size)
	if(Temp != NULL)	{
	    _strnset( Temp, fc, size );
		//insure NTS
	    Temp[size] = '\0';
		str = Temp;
		DEL_PTR(Temp)
	}
	return str._len;
}

int String::append( const char  *ss )
{
	char * 	Temp;
	int		newlen;

    if((ss == NULL) || (ss[0] == 0x00))
        return str._len;
    if(str.isnull())    {
        assign(ss);
    }
    else    {
    	newlen = str._len + strlen(ss);
    	NEW_PTR(Temp,newlen - 1)
		if(Temp != NULL)	{
		    strcpy(Temp,str._str);
			strcat(Temp,ss);
			str = Temp;
		    DEL_PTR(Temp)
		}
    }
	return str._len;
}

int String::assign( const char  *s )
{
	if (!str.isnull())	{
		str.clear();
		}
    if((s == NULL) || (s[0] == 0x00))
        return str._len;
	str = s;
	return str._len;
}

int	String::chrcnt(const char s)
{
	int i = 0,count = 0;

    if(str.isnull())
        return 0;
	while(str._str[i])	{
		if(str._str[i] == s)	{
			count++;
		}
		i++;
	}
	return count;
}

void String::clone(String *temp)
{
	(*temp) = (str._str);
}

void String::clone(String& ss)
{
	ss = str._str;
}

int String::reserve()
{
	return sizeof(str);
}

void String::resize(int m)
{
	char *	_s;

	NEW_PTR(_s,m)
	memset(_s,20,m);
    if(!str.isnull())    {
    	strncpy(_s,str._str,m);
    }
	str = _s;
	DEL_PTR(_s)
}

void String::strrpl(const char c1, const char c2)
{
	int i = 0;

    if(str.isnull())
        return;
	GrabMutex();
	while(str[i])	{
		if(str[i] == c1)	{
			str._str[i] = c2;
			}
        i++;
		}
	FreeMutex();
}

void String::strset(const char s)
{
	GrabMutex();
	if(!str.isnull())	{
		_strset( str._str, s );
        }
	FreeMutex();
}

//return a hash of the string...
//not terribly good for LONG strings.
unsigned long String::hash(void)
{
	unsigned long	hash;
	char			c;
	char		   *pb;
	int				tlen;

	hash = (long)(str._len - 1);
	tlen = str._len;
	pb = str._str;
	while(tlen--)   {
		c = *(pb++) | 32;       
		hash = (hash<<2) ^ c;
	}
	return hash;
}

void String::to_lower(void)
{
	GrabMutex();
    if(!str.isnull())
    	strlwr(str._str);
	FreeMutex();
}

void String::to_upper(void)
{
	GrabMutex();
    if(!str.isnull())
    	strupr(str._str);
	FreeMutex();
}

char String::get_at(int pos)
{
    if((str.isnull()) ||
       (pos > str._len))
		return nilchar;
	else
		return str[pos];
}

int String::put_at( int pos, char c )
{
    if(str.isnull())
        return -1;
	if(pos > (str._len - 1))
		return -1;
	GrabMutex();
	str._str[pos] = c;
	FreeMutex();
	return pos;
}

void String::set_at(int pos, char c)
{
	put_at(pos,c);
}

void String::reverse(void)
{
	GrabMutex();
	if(!str.isnull())	{
		_strrev( str._str );
	}
	FreeMutex();
}

void String::case_toggle(void)
{

	GrabMutex();
	if(m_case)
		m_case = 0;
	else
		m_case = 1;
	FreeMutex();
}

int String::search(const char  *word)
{
	return search(str._str,word);
}

// *** OVERLOAD BRACKETS            
// *********************
char String::operator [](int index) 
{
	return str[index];
}

String String::left(int len)
{
	//return the whole string
	if(len > (str._len - 1))	{
		return String(*this);
		}
	//pass parameters on...
	return String((*this),0,len);
}

String String::mid(int start, int len)
{
	//return the whole string
    if((start > (str._len - 1))	||
	   (start < 0))
        return String((*this));
	//return start pos to real end
    if((start + len) > (str._len - 1))	{
		return String((*this),start,str._len - 1 - start);
		}
	//pass parameters on
	return String((*this),start,len);
}

String String::right(int len)
{
    if(len > (str._len - 1))	{
		return String((*this),0,str._len - 1);
		}
	// params->    	 string	,   start pos		 ,count
	return String((*this),(str._len - 1 - len),len);
}

// *** getline
// ***********
void String::getline(istream &stream)
{
	char *temp;
	int   thelen;

    NEW_PTR(temp,MAX_TMP_LEN)
	stream.getline(temp,MAX_TMP_LEN-1);
	thelen = strlen(temp);

	if (!str.isnull())	{
		str.clear();
		}
	str = temp;
    DEL_PTR(temp)
}

int String::strindex(const char  *word)
{
	return search(str._str,word);
}

int String::append( const String &ss )
{
	return append(ss.str._str);
}

int String::append( const char ss )
{
	char * 	Temp;
	int		newlen;

    if(ss == NULL)
    	return str._len;
	newlen = str._len + 1;
	NEW_PTR(Temp,newlen - 1)
    if(Temp != NULL)    {
    	strcpy(Temp,str._str);
		Temp[newlen - 1] = ss;
    }
	str = Temp;
   	DEL_PTR(Temp)
	return str._len;
}

int String::append( const String &ss, int start, int n )
{
	return append(ss.c_str(), start, n);
}

int String::append( const char  *cp, int start, int n )
{
	char *Temp;
	char *ptc;
	int	  newlen;

    if((cp == NULL) || (cp[0] == 0x00))
        return str._len;
	ptc = (char *) cp;
	if(ptc != NULL)
		ptc += start;
	if(n == -1)	{
		newlen = str._len + strlen(cp);
	}
	else	{
		if(n < (int)(strlen(cp) - start))	{
			newlen = str._len + n;
			}
		else	{
			newlen = str._len + strlen(cp);
			n = -1;
			}
		}
	NEW_PTR(Temp,newlen - 1)
    if(Temp != NULL)	{
    	strcpy(Temp,str._str);
		if(n == -1)
			strcat(Temp,ptc);
		else
			strncat(Temp,ptc,n);
		str = Temp;
	    DEL_PTR(Temp)
	}
	return str._len;
}

int String::assign( String &s )
{
	if (&s == this)
		return str._len;
	return assign(s.c_str());
}

int String::assign( String &s, int start, int n )
{
	return assign(s.c_str(), start, n);
}

int String::assign( const char  *s, int start, int n )
{
	char  * ptc;
	char  * Temp;
	int		newlen;

    if((s == NULL) || (s[0] == 0x00))
        return str._len;
    if(start > (int)strlen(s))
        return str._len;
	ptc = (char *)s;
	if(start > (int)(strlen(s) -1))
		return -1;
	if (!str.isnull())	{
		str.clear();
		}
   	ptc += start;
	if(n == -1)
		newlen = (strlen(s) - start) + 1;
	else	{
		if(n < (int)(strlen(s) - start))	{
			newlen = (n + 1);
			}
		else	{
			newlen = (strlen(s) + 1);
			n = -1;
			}
		}
	NEW_PTR(Temp,newlen - 1)
	if(Temp != NULL)	{
		if(n == -1)
			strcpy(Temp,ptc);
		else
			strncpy(Temp,ptc,n);
		str = Temp;
		DEL_PTR(Temp)
	}
	return str._len;
}
		
int String::compare(String &s)
{
	return compare(s.c_str());
}

int String::compare(String &s, int orig, int n )
{
	return compare(s.c_str(), orig, n);
}

int String::compare(const char  * s)
{
    if((!str.isnull()) && (s != NULL))   {
    	if(m_case)	{
	    	return strcmp(str._str,s);
    	}
	    else	{
		    return _strnicmp(str._str,s,str._len);
    	}
    }
    //both null?
    return (str._str == s) ? 0 : -1;
}

int String::compare(char  * s, int orig, int n )
{
	char *	ptc;
	char *	tchar1;
	int		tlen;

    if((str.isnull()) || (s == NULL) || (s[0] == 0x00))
        return -1;
	if(orig > (int)strlen(s))
		return -1;
	ptc = s;
	if(n == -1)
		tlen = strlen(s) - orig;
	else	{
		if(n < (int)(strlen(s) - orig))	{
			tlen = n;
			}
		else	{
			tlen = strlen(s);
			n = -1;
			}
		}
	ptc += orig;
	if(tlen == 0)
		return -1;
	NEW_PTR(tchar1,tlen)
	if(n == -1)
		strcpy(tchar1, ptc);
	else
		strncpy(tchar1,ptc,n);
	if(m_case)	{
		tlen = strcmp(str._str,tchar1);
	}
	else	{
		tlen = _strnicmp(str._str,tchar1,n);
	}
	DEL_PTR(tchar1)
	return tlen;
}

int String::contains(const char  * pat)
{
    if((str.isnull())     || 
       (pat == NULL)      ||
       (pat[0] == 0x00))
        return 0;
	if(m_case)	{
		if(strstr(str._str,pat) != NULL)
			return 1;
		else
			return 0;
		}
	else	{
		char *	t1;
		char *	t2;
		int			ret = 0;

		NEW_PTR(t1,str._len - 1)
		NEW_PTR(t2,strlen(pat))
		strcpy(t1,str._str);
		strcpy(t2,pat);
		strupr(t1);
		strupr(t2);
		if(strstr(t1,t2) != NULL)
			ret = 1;
		DEL_PTR(t1)
		DEL_PTR(t2)
		return ret;
		}
}

int String::contains(String & s)
{
	return contains(s.c_str());
}

int String::copy( char  *cb, int n )
{
    if((str.isnull()) || (cb == NULL))
        return 0;
	if(n == -1)	{
		strcpy(cb,str._str);
		return str._len;
	}
	else	{
		if(n < str._len)	{
			strncpy(cb,str._str,n);
			return n;
		}
		else	{
			strncpy(cb,str._str,str._len);
			return str._len;
		}
	}
}

int String::copy( char  *cb, int n, int pos )
{
	char * ptc;

    if((str.isnull()) || (cb == NULL))
        return 0;
	if(pos > (str._len - 1))
		return -1;
	ptc = str._str;
	ptc += pos;

	if(n == -1)	{
		strcpy(cb,ptc);
		return (str._len - pos);
		}
	else	{
		if(n > (str._len - pos))
			n = str._len - pos;
		strncpy(cb,ptc,n);
		return (n);
		}
}

int String::find( String &s )
{
	return find(s.c_str());
}

int String::find( String &s, int pos )
{
	return find(s.c_str(), pos);
}

int String::find( const char  *s )
{
	return find(s,0);
}

int String::find( const char *s, int pos )
{
	char  *ptc;
	char  *start;
	int	   hold;

    if((str.isnull()) || (s == NULL))
        return -1;
	if(pos > (str._len - 1))
		return -1;
	if(m_case)	{
		start = str._str;
		start += pos;
		ptc = strstr(start,s);
		if(ptc != NULL)
			return (int)(ptc - str._str);
		}
	else	{
		char * temp1;
		char * temp2;

		NEW_PTR(temp1,strlen(s))
		NEW_PTR(temp2,str._len - 1)
		strcpy(temp1,s);
		strcpy(temp2,str._str);
		strupr(temp1);
		strupr(temp2);
		start = temp2;
		start += pos;
		ptc = strstr(start,temp1);
		if(ptc!=NULL)
			hold = (int)(ptc - temp2);
		DEL_PTR(temp1)
		DEL_PTR(temp2)
		if(ptc!=NULL)
			return hold;
		}
	return -1;
}

int String::find_first_of( String &s )
{
	return find_first_of(s.c_str(),0);
}

int String::find_first_of( String &s, int pos )
{
	return find_first_of(s.c_str(),pos);
}

int String::find_first_of( const char *s )
{
	return find_first_of(s,0);
}

//find first occurance of any character in the set
//defined by characters in [s], beginning at pos
//in this string and return the index i this string
//returns -1 if no characters i the set are in this string
int String::find_first_of( const char *s, int pos )
{
	unsigned int	i = 0;
	int				t, hold;
	char			*pstrt;
	char			*pfind;

	hold = str._len;
    if((str.isnull()) || (s == NULL))
        return -1;
	if(pos > (str._len - 1)) 
		return -1;
	pstrt = str._str + pos;
	while(s[i])	{
	   pfind = strchr( pstrt, s[i] );
	   if(pfind != NULL)	{
		   t =  (pfind - str._str);
		   if(t < hold)
			   hold = t;
	   }
       i++;
	}
    if(hold == str._len)
		return -1;
	return hold;
}

int String::find_first_not_of( String &s )
{
	return find_first_not_of(s.c_str(),0);
}

int String::find_first_not_of( String &s, int pos )
{
	return find_first_not_of(s.c_str(),pos);
}

int String::find_first_not_of( const char *s )
{
	return find_first_not_of(s,0);
}

int String::find_first_not_of( const char *s, int pos )
{
	int		i = 0;
	char	*ptc;

    if((str.isnull()) || (s == NULL))
        return -1;
	while( str[i])	{
		ptc = strchr(s,str[i]);
		if(ptc == NULL)	{
			return i;
		}
        i++;
	}
	return -1;
}

int String::find_last_of( String &s )
{
	return find_last_of(s.c_str(),0);
}

int String::find_last_of( String &s, int pos )
{
	return find_last_of(s.c_str(),pos);
}

int String::find_last_of( const char *s )
{
	return find_last_of(s,0);
}

int String::find_last_of( const char *s, int pos )
{
	unsigned int	i = 0;
	char			*pstrt;
	char			*pfind;

    if((str.isnull()) || (s == NULL))
        return -1;
	if(pos > (str._len - 1))
		return -1;
	pstrt = str._str + pos;
	while(s[i])	{
	   pfind = strrchr( pstrt, s[i] );
	   if(pfind != NULL)	{
		   return (pfind - str._str);
	   }
	}
	return -1;
}

int String::find_last_not_of( String &s )
{
	return find_last_not_of(s.c_str(),0);
}

int String::find_last_not_of( String &s, int pos )
{
	return find_last_not_of(s.c_str(),pos);
}

int String::find_last_not_of( const char *s )
{
	return find_last_not_of(s,0);
}

int String::find_last_not_of( const char *s, int pos )
{
	int		i;
	char	*ptc;

    i = str._len - 1;
    if((str.isnull()) || (s == NULL))
        return -1;
    while(i >= 0)	{
		ptc = strchr(s,str._str[i]);
		if(ptc == NULL)	{
			return i;
		}
        i--;
	}
	return -1;
}

int String::insert( int pos, String &s )
{
	return insert(pos, s.c_str());
}

int String::insert( int pos, String &s, int start, int n )
{
	return insert(pos, s.c_str(), start, n);
}

int String::insert( int pos, const char  *s )
{
	char  *tstr;
	char  *ptc;
	int	   newlen;	

    if(str.isnull())    {
        return assign(s);
    }
    if((s == NULL) || (s[0] == 0x00))
        return -1;
	if(pos > (str._len - 1))
		return -1;
	ptc = str._str;
	ptc += pos;

	newlen = str._len + strlen(s);

	NEW_PTR(tstr,newlen - 1)
	strncpy(tstr,str._str,pos);
	strcat(tstr,s);
	strcat(tstr,ptc);
	str = tstr;
	DEL_PTR(tstr)
	return str._len;
}

int String::insert( int pos, char  *s, int start, int n )
{
	char *ptc;
	char *_t;
	int	  size;

    if(str.isnull())
        return assign(s,start,n);
    if((s == NULL) || (s[0] == 0x00))
        return -1;
	ptc = s;
	if(n > (int)strlen(s))
		return -1;
	if(start > (int)strlen(s))
		return -1;
	size = strlen(s) - start;
	if(n > size)
		n = size;
	ptc += start;
	NEW_PTR(_t,(strlen(s)-n))
	strncpy(_t,ptc,n);
	size = insert(pos,_t);
	DEL_PTR(_t)
	return size;
}

int String::prepend(String &s )
{
	return prepend(s.c_str());
}

int String::prepend( String &s, int start, int n )
{
	return prepend(s.c_str(),start,n);
}

int String::prepend( const char  *cp )
{
	char * _t;

    if((cp == NULL) || (cp[0] == 0x00))
        return str._len;
    if(str.isnull())
        return assign(cp);
	NEW_PTR(_t,str._len + strlen(cp))
	strcpy(_t,cp);
	strcat(_t,str._str);
	str = _t;
	DEL_PTR(_t)
	return str._len;
}

int String::prepend( const char  *cp, int start, int n )
{
	char *_t;
	char *ptc;
	char *pcopy;
	int	  size;

    if((cp == NULL) || (cp[0] == 0x00))
        return str._len;
    if(str.isnull())
        return assign(cp,start,n);
	if(start > (int)strlen(cp))
		return -1;
	size = strlen(cp) - start;
	if(n > size)
		n = size;
	NEW_PTR(pcopy,strlen(cp))
	NEW_PTR(_t,n)
	strcpy(pcopy,cp);
	ptc = pcopy;
	ptc += start;
	strncpy(_t,ptc,n);
	size = prepend(_t);
	DEL_PTR(_t)
	DEL_PTR(pcopy)
	return size;
}

istream& String::read_line(istream &stream)
{
	getline(stream);
	return stream;
}

istream& String::read_string(istream &stream)
{
	String t;

	stream >> t;
	assign(t);
	return stream;
}

int String::rfind( String &s )
{
	return rfind(s.c_str());
}

int String::rfind( String &s, int pos )
{
	return rfind(s.c_str(),pos);
}

int String::rfind( const char * s )
{
	return rfind(s,(str._len - 1));
}

int String::rfind( const char * s, int pos )
{
	char *ptc;
	char *old;
	int	  offset = 0;

    if((str.isnull()) || 
       (s == NULL)        ||
       (s[0] == 0x00))
       return -1;
    if(m_case)	{
		old = strstr(str._str,s);
		if(old == NULL)
			return -1;
		while((old != NULL)		&&
				(offset < pos))	{
			ptc = old;
			old = strstr(ptc+1,s);
			offset = (int)(ptc - str._str);
			}
		}
	else	{
		char * temp1;
		char * temp2;

		NEW_PTR(temp1,strlen(s))
		NEW_PTR(temp2,str._len - 1)
		strcpy(temp1,s);
		strcpy(temp2,str._str);
		strupr(temp1);
		strupr(temp2);
		old = strstr(temp2,temp1);
		if(old == NULL)
			return -1;
		while((old != NULL)	&&
			  (offset < pos))	{
			ptc = old;
			old = strstr(ptc+1,temp1);
			offset = (int)(ptc - temp2);
			}
		DEL_PTR(temp1)
		DEL_PTR(temp2)
		}
	return offset;
}

int String::remove( int pos, int n )
{
	char *ptc;
	char *start;
	int   size;

    if(str.isnull())
        return -1;
    if(pos > (str._len - 1))
		return -1;
	size = (str._len - pos);
	if(n > size)
		n = size;
	if(n == -1)
		return remove(pos);
	if(n==0)
		return str._len;
	start = str._str;
	start += pos;
	start += n;

	NEW_PTR(ptc,(str._len - n))
	strncpy(ptc,str._str,pos);
	strcat(ptc,start);
	str = ptc;
	DEL_PTR(ptc)
	return str._len;
}

int String::replace( int pos, String &s, int n )
{
	return replace(pos, s.c_str(), n);
}

int String::replace( int pos, int n1, String &s, int start, int n2 )
{
	return replace(pos, n1, s.c_str(), start, n2);
}

int String::replace( int pos, const char *s, int n )
{
	int	  size;
	char *ptc;
	char *start;

    if((str.isnull())    ||
       (s == NULL)       ||
       (s[0] == 0x00))
       return -1;
	if(pos > (str._len - 1))
		return -1;
	if(n > (str._len - pos))
		n = (str._len - pos);
	if(n == -1)
		size = strlen(s) + pos;
	else
		size = str._len - 1;
	NEW_PTR(ptc,size)
	strncpy(ptc,str._str,pos);
	start = str._str;
	start += pos;
	if(n != -1)
		start += n;
	strcat(ptc,s);
	strcat(ptc,start);
	str = ptc;
	DEL_PTR(ptc)
	return str._len;
}

int String::replace( int pos, int n1, const char * s, int start, int n2 )
{
	char *tstr;
	char *ptc;
	char *hold;
	int	  retval;

    if((str.isnull())    ||
       (s == NULL)       ||
       (s[0] == 0x00))
       return -1;
	if(start > (int)strlen(s))
		return -1;
	NEW_PTR(hold,strlen(s))
	strcpy(hold,s);
	ptc = hold;
	if(n2 > (int)(strlen(s) - start))
		n2 = (strlen(s) - start);
	NEW_PTR(tstr,n2)
	ptc += start;
	strncpy(tstr,ptc,n2);
	retval = replace(pos,tstr,n1);
	DEL_PTR(tstr)
	DEL_PTR(hold)
	return retval;
}

void String::strip(StripType t)
{
	switch(t)	{
		case Leading:
			striplead();
			break;
		case Trailing:
			striptail();
			break;
		case Both:
			striplead();
			striptail();
			break;
		}
}

// may generate a warning during compile...
// I have not yet worked out a 'pretty' solution for this...
// so we live with creating a temporary.
String String::substr( int pos )
{	  
	return substr(pos,str._len - 1);
}

String String::substr( int pos, int n )
{
	if(pos > (str._len - 1))	{
		return String(*this);
		}
	return (char *)String((*this),pos,n);
}

int	String::strstr_cnt(const char *s)
{
	int i = 0,j,k, count = 0;

    if((str.isnull()) || (s == NULL))
        return count;;
    while(str[i])	{
		for(j = i, k = 0; str[j] == s[k]; j++, k++)	{
			if(!s[k+1])	{
				count++;
				k++;
			}
		}
        i++;
	}
	return count;
}

int	String::strstr_cnt(String &s)
{
	return strstr_cnt(s.c_str());
}

int String::substrrpl(String &SubOld, String &SubNew)
{
	return substrrpl(SubOld.c_str(), SubNew.c_str());
}

int String::substrrpl(String &SubOld, const char *SubNew)
{
	return substrrpl(SubOld.c_str(), SubNew);
}

int String::substrrpl(const char *SubOld, String &SubNew)
{
	return substrrpl(SubOld, SubNew.c_str());
}

//replaces only the first occurrence of the old substring
int String::substrrpl(const char *SubOld, const char *SubNew, int num_repl)
{
	char *pc;
	char *hold;
	int	  newlen, ct = 0;
	unsigned int offset;

	if(num_repl == 0)
		num_repl = 65534;

    if((str.isnull())    || 
       (SubOld == NULL)  ||
       (SubNew == NULL))
       return 0;
    newlen = (str._len - 1) + (strlen(SubNew) - strlen(SubOld));
	if(newlen <= 0)
		return 0;
	pc = strstr(str._str,SubOld);
	while ((pc != NULL) && (ct < num_repl))	{
	    newlen = (str._len - 1) + (strlen(SubNew) - strlen(SubOld));
		NEW_PTR(hold,newlen)
		offset = pc - str._str;
		*pc = '\0';
		strcpy(hold,str._str);
		strcat(hold,SubNew);
		pc+= strlen(SubOld);
		strcat(hold,pc);
		str = hold;
		offset += strlen(SubNew);
		pc = strstr((str._str + offset),SubOld);
		++ct;
	}
	return ct;
}

//protected member functions
int String::removechars( int pos )
{
	char * 	ptc;

    if((str.isnull())           ||
	   (pos > (str._len - 1)))
		return -1;
	if((str._len - pos) == 0)
		return str._len;
	if(pos == 0)	{
		str.clear();
		return 0;
		}
	else	{
		NEW_PTR(ptc,(str._len - pos))
		strncpy(ptc,str._str,pos);
		str = ptc;
		DEL_PTR(ptc)
		return str._len;
		}
}

//generically search any one string for another
int String::search(const char  *searchstr, const char  *word)
{
	int idx,i,ret,j=0;
	char * s_work;
	char * w_work;

    if((searchstr == NULL) || (word == NULL))
        return -1;
	NEW_PTR(s_work,strlen(searchstr))
	NEW_PTR(w_work,strlen(word))
	strcpy(s_work,searchstr);
	strcpy(w_work,word);

	if(!m_case)	{
		strupr(s_work);
		strupr(w_work);
		}
	for (i=0; s_work[i]; i++)	{
		if (s_work[i] == w_work[j])	{
			if (!j) idx = i;
			j++;
			}
		else
			j = 0;
		}

	if (w_work[j] != '\0')
		ret = -1;
	else
		ret = idx;
	DEL_PTR(s_work)
	DEL_PTR(w_work)
	return ret;
}

void String::striplead(void)
{
	char *ptc;
	char *_t;
	int	  cnt =0;

    if(str.isnull())
        return;
	ptc = str._str;
	while(isspace(*ptc)	&&
		  (cnt < (str._len - 1)))	{
		++ptc;
		++cnt;
		}
	str._len -= cnt;
	if(str._len <= 1)	{
		str.clear();
		return;
		}
	NEW_PTR(_t,str._len - 1)
	strcpy(_t,ptc);
	str = _t;
	DEL_PTR(_t)
}

void String::striptail(void)
{
	char *ptc;
	char *_t;
	int	  cnt;

    if(str.isnull())
        return;
    cnt = str._len - 1;
	ptc = str._str;		  
	ptc += (str._len - 1);
	--ptc;
	GrabMutex();
	while((isspace(*ptc)	||
		  (*ptc == '\n')	||
		  (*ptc == '\r'))	&&
		  (cnt > 0))		{
		*ptc = '\0';
		--ptc;
		--cnt;
		}
	FreeMutex();
	if(cnt == 0)	{
        str.clear();
		return;
		}
	//this will remove garbola...
	NEW_PTR(_t,strlen(str._str) + 1)
	strcpy(_t,str._str);
	str = _t;
	DEL_PTR(_t)
}

String &String::operator = (const char *y)
{
    if(!str.isnull())    {
        str.clear();
    }
    if(y != NULL)    {
        str = y;
    }
    return (*this);
}

String &String::operator = (const String &y)
{
    str = y.str;
	return (*this);
}

String::operator char  *()
{
	return (char *)str;
}

String::operator unsigned char  *()
{
	return (unsigned char *)str;
}

//protected stuff
//mutex stuff for those occasions not covered in str_node
void String::GrabMutex(void)
{
#ifdef WIN32
//	EnterCriticalSection(&str.m_CS);
#endif
}

void String::FreeMutex(void)
{
#ifdef WIN32
//	LeaveCriticalSection(&str.m_CS);
#endif
}

String String::add(const char *aa, const char *bb)
{
	String Temp;
	int	   chk;	

	if((aa != NULL)	&& (aa[0] != 0x00)){
		if((bb != NULL) && (bb[0] != 0x00))	{
			chk = 3;
		}
		else	{
			chk = 1;
		}
	}
	else	{
		if((bb != NULL) && (bb[0] != 0x00))	{
			chk = 2;
		}
		else	{
			chk = 0;
		}
	}
	switch(chk)	{
	case 0:
		return String();
		break;
	case 1:
		return String(aa);
		break;
	case 2:
		return String(bb);
		break;
	case 3:
		Temp = aa;
		Temp += bb;
		return String(Temp.c_str());
		break;
	}
	return String();
}

void String::remove_all_of(String &set)
{
	remove_all_of(set.c_str());
}

void String::remove_all_of(const char *set)
{
	char *	temp;
	int		i = 0, j = 0;

	if((set == NULL) || (set[0] == 0x00))	{
		return;
	}
	NEW_PTR(temp,str._len)
	while(str._str[i])	{
		if(strchr(set,str._str[i]) == NULL)	{
			temp[j] = str._str[i];
			j++;
		}
		i++;
	}
	str = temp;
	DEL_PTR(temp)
}

void String::remove_all_not_of(String &set)
{
	remove_all_not_of(set.c_str());
}

void String::remove_all_not_of(const char *set)
{
	char *	temp;
	int		i = 0, j = 0;

	if((set == NULL) || (set[0] == 0x00))	{
		return;
	}
	NEW_PTR(temp,str._len)
	while(str._str[i])	{
		if(strchr(set,str._str[i]) != NULL)	{
			temp[j] = str._str[i];
			j++;
		}
		i++;
	}
	str = temp;
	DEL_PTR(temp)
}
