/*

Simple test template of any concole code I've writen
*/


#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

// STL
// #include <string>

#include "Matrix.h"
#include "RotationMatrix.h"
#include "TransformationMatrix.h"
#include "Vector.h"
#include "Quaternion.h"

/*
#ifndef PI
#define PI 3.14159265358979323846
#endif

#ifndef RAD
#define RAD(x) ((x)*PI/180)
#endif
*/

using namespace std;

/*
void test1(void);
void test2(void);
void test3(void);
*/

/** -----------------------------------------------------------	``	
 *
 * Test Program
 *
 * ------------------------------------------------------------
 **/
int main(int argc, char *argv[])
{
	// t_Bone skel;
	
	// CMatrix::test();
	// test3();
	// bool result = LoadBVH("../../data/lucas/kicks3.bvh",&skel);
	// CQuaternion::test();
	
	// WriteBVH("../../data/lucas/_kicks3.bvh", &skel);
	// test load and write BVH files
	
	return 0;	
}

/*
void test3(void)
{
	CVector3 v1(-0.195, 0.107, 0.975);
	CVector3 v2(-0.116 , -4.419, 0.464);
	CVector3 v3(1.296, -3.947, 0.694);

	std::cout << (v2.cross(v3)).normalized() << std::endl;
	std::cout << v2*v1 << std::endl;
	std::cout << v3*v1 << std::endl;

}

void test2(void)
{
	//CQuaternion q, q1;
	//q.eulerToQuaternion( -2.160000, -0.980000,  -92.540001);
	//q1.eulerToQuaternion( -2.160000,   -0.980000,   87.459999);
	//std::cout << q1.inverted().normalized() << std::endl;
	//std::cout << q.normalized() << std::endl;
	//std::cout << q1.normalized() << std::endl;


	CQuaternion q(1.2, CVector3(3, 7, 2).normalized());
	CQuaternion qn = q*3;

	std::cout << "\nq            : " << q;
	std::cout << "\nq.normalized : " << qn;
	std::cout << "\nq angle      : " << q.getAngle();
	std::cout << "\nqn angle     : " << qn.getAngle();

	CVector3 test(1, 0, 0);
	CVector3 test2(1, 1, 0);

	CQuaternion r(test, test2);
	std::cout << "\n angle :" << DEG(r.getAngle()) << " | axis :" << r.getAxis(); 
	std::cout << "\nr.rotate(test) : " << r.rotate(test);

	CVector3 t3(12, 4, 25);
	CVector3 t4(-2, 8, -0.3);
	
	std::cout << "\nt3    :" << t3;
	std::cout << "\nt4    :" << t4;

	CQuaternion r1(t3, t4);
	std::cout << "\n angle :" << DEG(r1.getAngle()) << " | axis :" << r1.getAxis(); 
	std::cout << "\nUnnormalized : r.rotate(test) : " << r1.rotate(t3);

	std::cout << "\nt3.nor:" << t3.normalize();
	std::cout << "\nt4.nor:" << t4.normalize();

	CQuaternion r2(t3, t4);
	std::cout << "\n angle :" << DEG(r2.getAngle()) << " | axis :" << r2.getAxis(); 
	std::cout << "\nNormalized : r.rotate(test) : " << r2.rotate(t3);

	r2.normalize();
	std::cout << "\n angle :" << DEG(r2.getAngle()) << " | axis :" << r2.getAxis(); 
	std::cout << "\nNormalized : r.rotate(test) : " << r2.rotate(t3);


	CVector3 t5(-0.226, -8.257 , 2.194);
	CVector3 t6(1.507, -8.337, 1.113);
	
	std::cout << "\nt5    :" << t5;
	std::cout << "\nt6    :" << t6;

	CQuaternion r4(t5, t6);
	std::cout << "\n angle :" << DEG(r4.getAngle()) << " | axis :" << r4.getAxis(); 
	std::cout << "\nUnnormalized : r.rotate(test) : " << r4.rotate(t5);
		
}

void test1(void)
{
	double d0[] = {0.99965, -0.01876, 0.01861, -8.6214, 0.01689, 0.99524, 0.09602, 5.61070, -0.02033, -0.09567, 0.99521, -9.03306, 0, 0, 0, 1};
	double *d = new double[16];
	for(int i = 0; i < 16; i++)
		d[i] = d0[i];

	CVector3 pr(-8.6214, 5.6107, -9.03306);
	CVector3 ph(-8.120, 5.619, -9.043);
	CVector3 pk(-7.866, 2.933, -8.859);
	CVector3 pa(-8.160, 0.567, -9.354);

	CVector3 oh(0.501941, 0, 0);
	CVector3 ok(0, -2.70458, 0);
	CVector3 oa(0, -2.43537, 0);
	CVector3 oheel(0, -0.473545, 0);

	CVector3 rr(1.08, -5.49, 1.17);
	CQuaternion qr(0.999, -0.048, -0.011, -0.010);
	CQuaternion qh(0.993, 0.009, 0.108, 0.039);
	CQuaternion qk(0.984, 0.161, 0.045, -0.064);
	CQuaternion qa(0.986, -0.135, 0.002, 0.100);

	CQuaternion gra(0.919, 0.044, 0.389, -0.043);

	CTransformationMatrix mr(CRotationMatrix(RAD(-5.49), RAD(1.17), RAD(1.08), ZXY), pr);
	CQuaternion qmr(mr.getRotation());
	std::cout << qmr << std::endl;
	std::cout << mr << std::endl;
	CTransformationMatrix mt(d);
	std::cout << mt << std::endl;
	
	// oh.normalize();
	CVector3 gph = mt*oh;
	std::cout << "\nctm * oh" <<  gph << std::endl;
	CVector3 gpk = qh.rotate(ok) + gph;
	CVector3 gpa = qh.rotate(oa) + gpk;

	// all these are right channels
	CQuaternion qrr, qhr, qhk, qha;
	qrr.eulerToQuaternion2(RAD(-5.49), RAD(1.17), RAD(1.08), CHANNEL_TYPE_RZXY);
	qhr.eulerToQuaternion2(RAD(1.47), RAD(12.39), RAD(4.33), CHANNEL_TYPE_RZXY);
	qhk.eulerToQuaternion2(RAD(18.15), RAD(6.56), RAD(-8.5), CHANNEL_TYPE_RZXY);
	qha.eulerToQuaternion2(RAD(-15.36), RAD(1.86), RAD(11.84), CHANNEL_TYPE_RZXY);
	// qht.eulerToQuaternion2(RAD(39.3), RAD(0), RAD(0), CHANNEL_TYPE_RZXY);

// -8.5 18.15 6.56 11.84 -15.36 1.86 0 39.3 0 -2.12 -3.83 -18.39 1.09 26.21 
	// std::cout << "axis_angle" << qrr.getAxis() << " | " << qrr.getAngle() << std::endl;
	gph = qrr.rotate(oh) + pr;
	std::cout << "\ngph   : " << gph << std::endl;
	gpk = qrr.rotate(qhr.rotate(ok)) + gph;
	std::cout << "\ngpk   : " << gpk << std::endl;
	gpa = qrr.rotate(qhr.rotate(qhk.rotate(oa))) + gpk;
	std::cout << "\ngpa   : " << gpa << std::endl;
	CQuaternion gqa = qha*qhk*qhr*qrr;
	CQuaternion gqa1 = qhk*qhr*qrr;
	CQuaternion gqk = qhr*qrr;
	CVector3 gpk1 = gqk.rotate(ok) + gph;
	CVector3 gpa1 = gqa1.rotate(oa) + gpk1;
	std::cout << "\ngpk1  : " << gpk1 << std::endl;
	std::cout << "\ngpa2  : " << gpa1 << std::endl;
	std::cout << "\ngqa   : " << gqa << std::endl;
	std::cout << "\nqha   : " << qha << std::endl;

	CQuaternion qa1(0.9838, -0.00529, 0.16089, 0.07838);
	CVector3 oh1(0, -0.469495, 0);
	CVector3 pa1(-8.846, 0.613, -9.233);

	CVector3 ch1 = gqa.rotate(oheel) + gpa;
 	std::cout << "\ngpa   : " << ch1 << std::endl;
	std::cout << "\ngpa   : " << gpa << std::endl;
	CVector3 gpheel = gqa.rotate(oheel) + gpa;
	// std::cout << "\noheel : " << oheel << std::endl;
	std::cout << "\ngpheel   : " << gpheel << std::endl;
	// gpk = qhr.rotate(ok) + gph;
	// std::cout << gpk << std::endl;
	// std::cout << gpk << std::endl;
	// std::cout << gpa << std::endl;
	// std::cout << qhr << std::endl;

}
*/