/** =================================================================\n
 *
 * Mesh Compression Project - CS 7491 2004 project 1\n
 * @file Mesh.h
 *
 * Primary Authors: Brandon Beck
 *					Nguyen Truong (nltruong@cc.gatech.edu)\n
 *                  Howard Zhou (howardz@cc.gatech.edu)\n
 *
 * (C) Copyright 2004\n
 * (C) Copyright Georgia Institute of Technology, 2004\n
 *
 * ==================================================================\n
 * Basic Mesh class definition
 *
 * @version 1.0\n
 *     Initial Revision
 * @date 2004-02-14
 * @author Brandon Beck, Nguyen Truong, Howard Zhou
 *
 *
 * @todo
 * @bug
 * @warning 
 *
 * ===================================================================\n
 */

#ifndef __CMESH_H__
#define __CMESH_H__


// #include "common.h"

/// @namespace using standard namespace
using namespace std;

// ==================================================================================
/**
 * @class CMesh
 * @brief General Mesh class definition
 * @ingroup Mesh
 *
 * @par requirements
 *
 * @par license
 * This code is absolutely free to use and modify. The code is provided "as is" with
 * no expressed or implied warranty. The author accepts no liability if it causes
 * any damage to your computer, causes your pet to fall ill, increases baldness
 * or makes your car start emitting strange noises when you start it up.
 * This code has no bugs, just undocumented features!
 *
 * 
 * @version 1.0\n
 *     Initial Revision
 * @date 2004-02-14
 * @author Nguyen Truong & Howard Zhou
 *
 * This class is a general mesh class. This is an abstract class serving as the mesh
 * interface.
 * 
 * @todo
 * @bug
 * @warning
 */
// ================================================================================


class CMesh
{
protected:
			///< 	

private:
	// ------------------------------------------------------
	// private helpers
	// ------------------------------------------------------

public:
	// ------------------------------------------------------
	// constructors and destructors
	// ------------------------------------------------------

	/// Default constructor. Creates an uninitialized matrix.
	CMesh (){};

	// Destructor
	~CMesh (){};

	// ------------------------------------------------------
	// Predicators
	// ------------------------------------------------------
	virtual	bool isValid() const = 0;

	// ------------------------------------------------------
	// Accessors and Mutators
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Overloaded Operators 
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Input, Output, and Test
	// ------------------------------------------------------
	virtual void readFile	(const char* filename) = 0;
	virtual void writeFile	(const char* filename) const = 0;
	virtual void draw		() const = 0;

	// ------------------------------------------------------
	// Other operation
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Friend functions
	// ------------------------------------------------------

};

#endif // __CMESH_H__