/** =================================================================\n
 *
 * OpenGL window display MFC class
 * file Display.h
 * 
 * Primary Authors: Nguyen Truong (nltruong@cc.gatech.edu)\n
 *                  Howard Zhou (howardz@cc.gatech.edu)\n
 *
 * (C) Copyright 2004\n
 * (C) Copyright Georgia Institute of Technology, 2004\n
 *
 * ==================================================================\n
 * OpenGL window display MFC class
 *
 *
 * @version 1.1\n
 *	   Added a constructor that takes in height and width
 * @date 2004-02-18
 * @author Brandon Beck, Nguyen Le Truong, and Howard Zhou
 *
 *
 * @todo
 * @bug
 * @warning 
 *
 * ===================================================================\n
 */
#ifndef __CDISPLAY_H__
#define __CDISPLAY_H__

#include <vector>

#include "..\MatrixLib\Vector.h"
#include "OpenGLWindow.h"
#include "Listener.h"

// using namespace std;

// ==================================================================================
/**
 * @class CDisplay
 * OpenGL window display MFC class
 * @ingroup OpenGL
 *
 * @par requirements
 *
 * @par license
 * This code is absolutely free to use and modify. The code is provided "as is" with
 * no expressed or implied warranty. The author accepts no liability if it causes
 * any damage to your computer, causes your pet to fall ill, increases baldness
 * or makes your car start emitting strange noises when you start it up.
 * This code has no bugs, just undocumented features.
 *
 *
 * @version 1.1\n
 *	   Added a constructor that takes in height and width
 * @date 2004-02-18
 * @author Brandon Beck, Nguyen Le Truong, and Howard Zhou
 *
 * 
 * @todo
 * @bug
 * @warning
 */
// ================================================================================

class CDisplay : public COpenGLWindow
{
	vector<CPoint3D> _points;

public:

	// ------------------------------------------------------
	// constructors and destructors
	// ------------------------------------------------------
	///< default constructor
	CDisplay():COpenGLWindow(){};

	///< constructor with specified height and width
	CDisplay(int height, int width):COpenGLWindow(height, width){};

	///< destructor
	~CDisplay(){};

	// ------------------------------------------------------
	// Predicators
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Accessors and Mutators
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Overloaded Operators 
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Input, Output, and Test
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Other operation
	// ------------------------------------------------------
	virtual int  DrawGLScene(void);
	void DrawGLCube(void);
	void DrawGLPyramid(void);

	void setPoints(vector<CPoint3D> points)
	{
		_points = points;
	}

	void drawPoints(vector<CPoint3D> points);
	void drawSquare(double x, double y, double z, double size);
};


#endif	// __CDISPLAY_H__