#include <windows.h>
#include <GL\gl.h>
#include <GL\glu.h>
#include <GL\glaux.h>
// #include <GL\glut.h>
#include <stdlib.h>
#include <math.h>
#include "Listener.h"
#include <iostream>

#include "glut.h"

using namespace std;


GLfloat xrot = 0.0;
GLfloat yrot = 0.0;
GLfloat angleOfRot = 0.0;
GLfloat axisOfRotx = 0.0;
GLfloat axisOfRoty = 0.0;
GLfloat axisOfRotz = 0.0;

GLfloat x = 0.0;
GLfloat y = 0.0;
GLfloat z = 0.0;
GLfloat d = 0.0;
GLfloat moveIn = 0.0f;
int mouseX;
int mouseY;

GLfloat* m = new GLfloat[16];

bool firstTime = true;
bool mouseDown = false;
bool bKeepRot = false;
bool bMotion = false;
bool bAltClicked = false;

void (*mouseFunc)(int, int, int, int) = NULL;
void (*mouseMotionFunc)(int, int) = NULL;
void (*displayFunc)(void) = NULL;

void processChange()
{
	glLoadIdentity();

	glTranslatef(moveIn*x, moveIn*y, moveIn*z);

	x = x+moveIn*x;
	y = y+moveIn*y;
	z = z+moveIn*z;

	glTranslatef(x, y, z);  // translate to the point clicked

	// Draw a sphere about the point of rotation
	glColor3f(0.0f,0.0f,1.0f);
	glutSolidSphere(0.1f, 32, 32);

	// rotate about the point by a certain rotation
	glRotatef(-xrot,1.0f, 0.0f, 0.0f);
	glRotatef(-yrot, 0.0f, 1.0f, 0.0f);

	// translate back to scene origin
	glTranslatef(-x, -y, -z);

	if(!firstTime)
		glMultMatrixf(m);  // multiply the top matrix in the stack by m
	else
		firstTime = false;

	// store the top matrix from the stack into m
	glGetFloatv(GL_MODELVIEW_MATRIX, m);

	glutSwapBuffers();
}

void TesterMouseMotionCallback(int xloc, int yloc)
{
	bMotion = true;
	if(mouseMotionFunc != NULL)
		mouseMotionFunc(xloc, yloc);

	if(bAltClicked)
	  moveIn = 0.001*z*(mouseY-yloc);
	else
	{
	  yrot = 0.7f * (float)(mouseX - xloc);
	  xrot = 0.7f * (float)(mouseY - yloc);
	} // end else

	if(!bAltClicked &&
		((mouseX - xloc) < -3) || ((mouseX - xloc) > 3) ||
		((mouseY - yloc) < -3) || ((mouseY - yloc) > 3))
		bKeepRot = true;
	else
		bKeepRot = false;

	mouseX = xloc;
	mouseY = yloc;
} // end TesterMouseMotionCallback

void TesterMouseCallback(int button, int state, int xloc, int yloc)
{
	if(mouseFunc != NULL)
		mouseFunc(button, state, xloc, yloc);

	glLoadIdentity();
	int mod = glutGetModifiers();

	if((button == GLUT_LEFT_BUTTON) &&
	   (state == GLUT_DOWN) &&
	   (mod == GLUT_ACTIVE_SHIFT))
	  {
	    mouseDown = true;
	    GLfloat* zbuf = new GLfloat[1];
	    // read the zbuffer at the location of the mouse click
	    glReadPixels(xloc, glutGet(GLUT_WINDOW_WIDTH)-yloc,
			1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, zbuf);
		if(zbuf[0] != 1)
		{
			GLdouble* model = new GLdouble[16];
			glGetDoublev(GL_MODELVIEW_MATRIX, model);
			GLdouble* proj = new GLdouble[16];
			glGetDoublev(GL_PROJECTION_MATRIX, proj);
			GLint* vp = new GLint[4];
			glGetIntegerv(GL_VIEWPORT, vp);

			GLdouble xt;
			GLdouble yt;
			GLdouble zt;

			// get the coordinates in the scene world
			gluUnProject(xloc, glutGet(GLUT_WINDOW_WIDTH)-yloc, zbuf[0], model, proj, 
vp, &xt, &yt, &zt);
			x = xt;
			y = yt;
			z = zt;
		} // end if
	} // end if
	else if((button == GLUT_LEFT_BUTTON) &&
		(state == GLUT_DOWN) &&
		(mod == GLUT_ACTIVE_ALT)){
		mouseDown = true;
		bAltClicked = true;
	}
	else if((button == GLUT_LEFT_BUTTON) &&
		(state == GLUT_UP))
	{
		if(!bMotion)
			bKeepRot = false;

		mouseDown = false;
		bAltClicked = false;
		bMotion = false;
		angleOfRot = 0;
	} // end else

	mouseX = xloc;
	mouseY = yloc;
}

void TesterDisplayCallback(void)
{
	processChange();
	angleOfRot = 0.0;
	moveIn = 0.0;
	if(!bKeepRot || mouseDown)
	{
		xrot = 0.0f;
		yrot = 0.0f;
	} // end if
	if(displayFunc != NULL)
		displayFunc();
}

void findD()
{
	GLdouble* model = new GLdouble[16];
	glGetDoublev(GL_MODELVIEW_MATRIX, model);
	GLdouble* proj = new GLdouble[16];
	glGetDoublev(GL_PROJECTION_MATRIX, proj);
	GLint* vp = new GLint[4];
	glGetIntegerv(GL_VIEWPORT, vp);

	GLdouble xt;
	GLdouble yt;
	GLdouble zt;

	// get the coordinates in the scene world
	gluProject(0, 0, 0.5, model, proj, vp, &xt, &yt, &zt);
	d = (float)((0.5*zt) / (zt - 0.5));
}

void setupListeners()
{
	findD();
	glutMouseFunc(TesterMouseCallback);
	glutMotionFunc(TesterMouseMotionCallback);
	glutDisplayFunc(TesterDisplayCallback);
}

void setupDisplay(void (*ptrDisplayFunc)(void))
{
	displayFunc = ptrDisplayFunc;
}

