/** =================================================================\n
 *
 * Simple MFC, C++ OpenGL Tutorial Program
 * file OpenGLWindow.h
 * 
 * Primary Authors: Nguyen Truong (nltruong@cc.gatech.edu)\n
 *                  Howard Zhou (howardz@cc.gatech.edu)\n
 *
 * (C) Copyright 2004\n
 * (C) Copyright Georgia Institute of Technology, 2004\n
 *
 * ==================================================================\n
 * smotri - Simple MFC, C++, OpenGL Tutorial Program
 *
 *
 * @version 1.1\n
 *	   Added a constructor that takes in height and width
 * @date 2004-02-18
 * @author Howard Zhou
 *
 * @version 1.0\n
 *     Initial Revision
 * @date 2000-10-09
 * @author Joel Parris
 *
 *
 * @todo
 * @bug
 * @warning 
 *
 * ===================================================================\n
 */

#ifndef __COPENGLWINDOW_H__
#define __COPENGLWINDOW_H__

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows 95 and Windows NT 4 or later.
#define WINVER 0x0400		// Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows NT 4 or later.
#define _WIN32_WINNT 0x0400		// Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE			// Allow use of features specific to IE 4.0 or later.
#define _WIN32_IE 0x0400	// Change this to the appropriate value to target IE 5.0 or later.
#endif


#include <afxwin.h>		// MFC Windows include file
#include <GL/gl.h>		// OpenGL include file
#include <GL/glu.h>		// OpenGL Utilities include file
// #include <GL/glut.h>
#include <math.h> 

#include "glut.h"


// ==================================================================================
/**
 * @class COpenGLWindow
 * @smotri - Simple MFC, C++, OpenGL Tutorial Program
 * @ingroup OpenGL
 *
 * @par requirements
 *
 * @par license
 * This code is absolutely free to use and modify. The code is provided "as is" with
 * no expressed or implied warranty. The author accepts no liability if it causes
 * any damage to your computer, causes your pet to fall ill, increases baldness
 * or makes your car start emitting strange noises when you start it up.
 * This code has no bugs, just undocumented features.
 *
 *
 * @version 1.1\n
 *	   Added a constructor that takes in height and width
 * @date 2004-02-18
 * @author Howard Zhou
 *
 * @version 1.0\n
 *     Initial Revision
 * @date 2000-10-09
 * @author Joel Parris
 *
 *
 * smotri - Simple MFC, C++, OpenGL Tutorial Program
 * 
 * @todo
 * @bug
 * @warning
 */
// ================================================================================

class COpenGLWindow: public CFrameWnd
{
private:
	int _height;			///< height of the window
	int _width;				///< width of the window

public:

    HDC		m_hgldc;		///< GDI Device Context
    HGLRC	m_hglRC;		///< Rendering Context

	// ------------------------------------------------------
	// constructors and destructors
	// ------------------------------------------------------
	COpenGLWindow();		// COpenGLWindow Class Constructor

	COpenGLWindow(int height, int width);

	~COpenGLWindow();		// COpenGLWindow Class Destructor

	// ------------------------------------------------------
	// Predicators
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Accessors and Mutators
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Overloaded Operators 
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Input, Output, and Test
	// ------------------------------------------------------

	// ------------------------------------------------------
	// Other operation
	// ------------------------------------------------------
    BOOL SetPixelformat(HDC hdc); 
	void GetGLInfo();
	int  InitGL(void);
	void ReSizeGLScene(int width, int height);

    virtual BOOL PreCreateWindow( CREATESTRUCT& cs );

	// virtual function which all the children calls to do things
	virtual int  DrawGLScene(void) = 0;

	// ------------------------------------------------------
	// protected members
	// ------------------------------------------------------
protected:

    afx_msg void OnPaint();
    afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy );
    afx_msg BOOL OnEraseBkgnd( CDC* pDC );
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);

	DECLARE_MESSAGE_MAP()

};

#endif // __COPENGLWINDOW_H__