// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__B9860475_351C_4E83_92B5_E4437E60684C__INCLUDED_)
#define AFX_MAINFRM_H__B9860475_351C_4E83_92B5_E4437E60684C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define INFOBAR_SIZE 150	// constant for creating
							// splitter windows

#include "Perspective.h"
#include "Front.h"
#include "Top.h"
#include "Side.h"
#include "InfoPannel.h"

// forward declaration
class Task;

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	void (* _renderFunc) ( CTask* );		///< rendering function

	BOOL		 m_initSplitters;		// Have the splitters
										// been initialized?
	CSplitterWnd m_mainSplitter,		// Splitter windows
				 m_viewportSplitter;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// HOWARD
	// set the render function for all views
	void setRenderFunc ( void (*func) ( CTask* ));

	void setPaneRenderFunc (int row, int col);

	void updateView(int row, int col);
	void updateAllViews(void);

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__B9860475_351C_4E83_92B5_E4437E60684C__INCLUDED_)
