/** =================================================================\n
 *
 * CS 7491 2004\n
 * @file Task.h
 *
 * Primary Authors: Nguyen Truong (nltruong@cc.gatech.edu)\n
 *                  Howard Zhou (howardz@cc.gatech.edu)\n
 *
 * (C) Copyright 2004\n
 * (C) Copyright Georgia Institute of Technology, 2004\n
 *
 * ==================================================================\n
 * Basic Task class
 *
 * @version 1.0\n
 *     Initial Revision
 * @date 2004-02-13
 * @author Nguyen Truong & Howard Zhou
 *
 *
 * @todo
 * @bug
 * @warning 
 *
 * ===================================================================\n
 */

#ifndef __CTASK_H__
#define __CTASK_H__

#pragma warning(disable : 4786)
#pragma warning(disable : 4267) // conversion warning

#include <assert.h>

// local included files
#include "Viewer.h"
#include "MainFrm.h"

//using namespace std;

// forward declaration
class CViewerApp;

class CTask
{
protected:
	CViewerApp * _pApp;
	CMainFrame * _pWndMain;

public:

	// constructor
	CTask()
	{
		// get the main application
		_pApp = (CViewerApp*)AfxGetApp();
		_pWndMain = (CMainFrame*)AfxGetMainWnd();

		assert(_pApp != NULL);
		assert(_pWndMain != NULL);
	}

	// destructor
	~CTask(){};

	virtual void run() = 0;
};

#endif //  __CTASK_H__