// Viewer.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Viewer.h"

#include "MainFrm.h"
#include "ViewerDoc.h"
#include "ViewerView.h"
#include ".\viewer.h"

#include "..\CurveCompression\CurveCompression.h"
#include "..\MeshCompression\MeshCompression.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CViewerApp

BEGIN_MESSAGE_MAP(CViewerApp, CWinApp)
	//{{AFX_MSG_MAP(CViewerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_PROJECT_CURVECOMPRESSION, OnProjectCurveCompression)
	ON_COMMAND(ID_PROJECT_MESHCOMPRESSION, OnProjectMeshCompression)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewerApp construction

CViewerApp::CViewerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CViewerApp object

CViewerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CViewerApp initialization

BOOL CViewerApp::InitInstance()
{
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );


	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.
/*
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
*/
	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CViewerDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CViewerView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow( SW_SHOWMAXIMIZED );
	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CViewerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CViewerApp message handlers

void CViewerApp::OnFileOpen() 
{
	// Use our own OnFileOpen method so we can
	// implement our own file filters.

	static char szFilter[] = "Quake III Model Files (*.md3)|*.md3||";
	CFileDialog fileName( TRUE, "*.md3", NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter );

	// Stop the load process if the user clicked
	// cancel.
	if ( fileName.DoModal() != IDOK )
		return;

	// Continue using the framework to load the
	// document.
	CWinApp::OpenDocumentFile( fileName.GetPathName() );
}

void CViewerApp::OnProjectCurveCompression()
{
	CTask* cc = new CCurveCompression();

	if(NULL != cc)
	{
		_pTask = cc;
		cc->run();
	}
}

void CViewerApp::OnProjectMeshCompression()
{
	// _CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
	CTask* mc = new CMeshCompression();
	
	if(NULL != mc)
	{
		_pTask = mc;
		mc->run();
	}
}
